From ff8efc5d689ef048f5203593390f1ff6a052a5d5 Mon Sep 17 00:00:00 2001
From: =?UTF-8?q?Miro=20Hron=C4=8Dok?= <miro@hroncok.cz>
Date: Sun, 19 Jun 2022 18:32:04 +0200
Subject: [PATCH] Add support for Python 3.11 _posixsubprocess.fork_exec()
 arguments

---
 billiard/compat.py | 5 +++++
 1 file changed, 5 insertions(+)

diff --git a/billiard/compat.py b/billiard/compat.py
index 857ffd1..bea9746 100644
--- a/billiard/compat.py
+++ b/billiard/compat.py
@@ -1,6 +1,7 @@
 import errno
 import numbers
 import os
+import subprocess
 import sys
 
 from itertools import zip_longest
@@ -186,9 +187,13 @@ def spawnv_passfds(path, args, passfds):
                 args, [fsencode(path)], True, tuple(passfds), None, None,
                 -1, -1, -1, -1, -1, -1, errpipe_read, errpipe_write,
                 False, False]
+            if sys.version_info >= (3, 11):
+                args.append(-1)  # process_group
             if sys.version_info >= (3, 9):
                 args.extend((None, None, None, -1))  # group, extra_groups, user, umask
             args.append(None)  # preexec_fn
+            if sys.version_info >= (3, 11):
+                args.append(subprocess._USE_VFORK)
             return _posixsubprocess.fork_exec(*args)
         finally:
             os.close(errpipe_read)
